import java.io.*;

public class StudentListApplication {

  // Default Constructor
  public StudentListApplication() {

  }

  // Adds Student Names to List
  public void buildStudentList(StudentList value) {

    value.addStudent("Bob Robinson");
    value.addStudent("Steve Bobinson");
    value.addStudent("Rob Stevinson");
    value.addStudent("Todd Thompson");
    value.addStudent("Tom Toddson");
    value.addStudent("Rob Bobinson");
  }

  // Stores the Serializable StudentList to the file "file.dat"
  public void putStudentList(StudentList value) {

    try {

      // Create the ObjectOutputStream passing it the
      // FileOutputStream object that points to our
      // persistent storage.
      ObjectOutputStream os = new ObjectOutputStream(
        new FileOutputStream("file.dat"));
      // Write the StudentList to the ObjectOutputStream
      os.writeObject(value);
      os.flush();
      os.close();
    }
    catch (IOException e) {

      System.err.println(e.getMessage());
    }
  }

  public StudentList getStudentList() {

    StudentList list = null;

    try {

      // Create the ObjectInputStream passing it the
      // FileInputStream object that points to our
      // persistent storage.
      ObjectInputStream is = new ObjectInputStream(
        new FileInputStream("file.dat"));
      // Read the stored object and downcast it back to
      // a StudentList
      list = (StudentList)is.readObject();
      is.close();
    }
    catch (IOException e) {

      System.err.println(e.getMessage());
    }
    catch (ClassNotFoundException ce) {

      System.err.println(ce.getMessage());
    }
    return list;
  }

  public void invoke() {

    StudentList list = new StudentList();

    buildStudentList(list);

    System.out.println("Before being serialized.");
    list.listStudents();
    putStudentList(list);

    System.out.println("After being read back in.");
    // Get the StudentList and print it out
    StudentList inList = getStudentList();
    if ( inList != null ) {

      inList.listStudents();
    }
    else {

      System.err.println("readObject failed.");
    }
    try {

      System.out.println("\n Press enter to quit.");
      System.in.read();
    }
    catch (Exception e) {

      System.err.println(e.getMessage());
    }
  }

  public static void main(String[] args) {

    StudentListApplication studentListApplication =
      new StudentListApplication();

    studentListApplication.invoke();
  }
}
