import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

import ConnectionPool.*;

public class TitleListGlobalPooledServlet extends HttpServlet {

  public void init(ServletConfig config)
    throws ServletException {

    super.init(config);
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,
    HttpServletResponse response)
      throws ServletException, IOException {

    // If we get a GET request, pass the request/response to
    // the doPost() method
    doPost(request, response);
  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request,
    HttpServletResponse response)
    throws ServletException, IOException {

    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    out.println("<html>\n<body>\n<table border=\"1\" width=\"100%\">");

    Connection con = null;
    ConnectionPool pool = null;

    try {


      // Get a reference to the ConnectionPool from the Global
      // ServletContext
      pool =(ConnectionPool)
        getServletContext().getAttribute("CONNECTION_POOL");

      // Get a connection from the ConnectionPool
      con = pool.getConnection();

      if ( con != null ) {

        // Create the statement
        Statement statement = con.createStatement();

        // Use the created statement to SELECT the DATA
        // FROM the Titles Table.
        ResultSet rs = statement.executeQuery("SELECT * " +
         "FROM Titles");

        // Iterate over the ResultSet
        while ( rs.next() ) {

            out.println("<tr>");

            // get the id, which is an int
            out.println("<td>" + rs.getInt("title_id") + "</td>");

            // get the name, which is a String
            out.println("<td>" + rs.getString("title_name") + "</td>");

            // get the rating, which is a String
            out.println("<td>" + rs.getString("rating") + "</td>");

            // get the price, which is a Float
            out.println("<td>" + rs.getFloat("price") + "</td>");

            // get the Quantity, which is a Integer
            out.println("<td>" + rs.getInt("quantity") + "</td>");

            // get the Type, which is a Integer
            out.println("<td>" + rs.getInt("type_id") + "</td>");

            // get the Category, which is a Integer
            out.println("<td>" + rs.getInt("category_id") + "</td>");

            out.println("</tr>");
        }
        // Close the ResultSet
        rs.close();
        out.println("</table>");
      }
    }
    catch (SQLException sqle) {

      System.err.println(sqle.getMessage());
    }
    catch (Exception e) {

      System.err.println(e.getMessage());
    }
    finally {

      // Release the connection
      pool.releaseConnection(con);
    }
    out.println("</body></html>");
    out.close();
  }

  //Get Servlet information
  public String getServletInfo() {

    return "TitleListGlobalPooledServlet Information";
  }
}
