import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class TitleListServlet extends HttpServlet {

    public void init(ServletConfig config)
        throws ServletException {

        super.init(config);
    }

    //Process the HTTP Get request
    public void doGet(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        doPost(request, response);
    }

    //Process the HTTP Post request
    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        // Set the response content-type
        response.setContentType("text/html");
        // get the Writer object
        PrintWriter out = response.getWriter();

        out.println("<html>\n<body>\n<table border=\"1\" width=\"100%\">");

        // Get the search_string parameter, passed from the
        // SearchServlet.
        String search_string =
        request.getParameter("search_string");

        Connection con = null;

        try {

        // Load the Driver class file
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

        System.err.println("Getting Connection!");

        // Make a connection to the ODBC datasource Movie Catalog
        // In this example we are opening a connection to the
        // database with every request.
        con = DriverManager.getConnection("jdbc:odbc:Movie Catalog",
            "", "");

        if ( con != null ) {

            System.err.println("Got Connection!");

            // Create the statement
            Statement statement = con.createStatement();

            // Use the created statement to SELECT the DATA
            // FROM the Titles Table.
            // In this instance we are serching for an exact match.
            // If you were to deploy this to a production site, you
            // might want to use a "LIKE" clause instead of WHERE.
            ResultSet rs = statement.executeQuery("SELECT * " +
                "FROM Titles WHERE rating = '" +
            search_string + "'");


        // Iterate over the ResultSet
        while ( rs.next() ) {

            out.println("<tr>");

            // get the id, which is an int
            out.println("<td>" + rs.getInt("title_id") + "</td>");

            // get the name, which is a String
            out.println("<td>" + rs.getString("title_name") + "</td>");

            // get the rating, which is a String
            out.println("<td>" + rs.getString("rating") + "</td>");

            // get the price, which is a Float
            out.println("<td>" + rs.getFloat("price") + "</td>");

            // get the Quantity, which is a Integer
            out.println("<td>" + rs.getInt("quantity") + "</td>");

            // get the Type, which is a Integer
            out.println("<td>" + rs.getInt("type_id") + "</td>");

            // get the Category, which is a Integer
            out.println("<td>" + rs.getInt("category_id") + "</td>");

            out.println("</tr>");
        }
        // Close the ResultSet
        rs.close();
        out.println("</table>");
      }
    }
    catch (SQLException sqle) {

      System.err.println(sqle.getMessage());
    }
    catch (ClassNotFoundException cnfe) {

      System.err.println(cnfe.getMessage());
    }
    catch (Exception e) {

      System.err.println(e.getMessage());
    }
    finally {

      try {

        if ( con != null ) {

          // Close the connection no matter what
          con.close();
        }
      }
      catch (SQLException sqle) {

        System.err.println(sqle.getMessage());
      }
    }
    out.println("</body></html>");
    out.close();
  }

  //Get Servlet information
  public String getServletInfo() {

    return "TitleListServlet Information";
  }
}