import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class MailServlet extends HttpServlet {

    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    public void doGet(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        doPost(request, response);
    }

    public void doPost(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        // Create some properties and get the default Session.
        String host = "smtp.rmi.net";
        String to = request.getParameter("to");
        String from = request.getParameter("from");
        String subject = request.getParameter("subject");
        String messageText = request.getParameter("body");
        boolean sessionDebug = false;

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head><title>MailServlet</title></head>");

        Properties props = System.getProperties();
        props.put("mail.host", host);
        props.put("mail.transport.protocol", "smtp");

        Session mailSession = Session.getDefaultInstance(props, null);

        // Set debug on the Session so we can see what is going on
        // Passing false will not echo debug info, and passing true
        // will.
        mailSession.setDebug(sessionDebug);

        // Instantiate a new MimeMessage and fill it with the
        // required information.
        Message msg = new MimeMessage(mailSession);

        try {

            msg.setFrom(new InternetAddress(from));
            InternetAddress[] address = {new InternetAddress(to)};
            msg.setRecipients(Message.RecipientType.TO, address);
            msg.setSubject(subject);
            msg.setSentDate(new Date());
            msg.setText(messageText);

            // Hand the message to the default transport service
            // for delivery.
            Transport.send(msg);

            out.println("<body>");

            out.println("Mail was sent to " + to);
            out.println(" from " + from);
            out.println(" using host " + host + ".");

            out.println("</body></html>");
        }
        catch (MessagingException mex) {

            mex.printStackTrace();
        }
        finally {

            out.close();
        }
    }
}
