import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import java.util.Hashtable;
import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.parsers.*;
import SAXHandler;

public class XMLServlet extends HttpServlet {

    private static final String CONTENT_TYPE = "text/html";

    private String moviefile = "C:\\jakarta-tomcat\\webapps\\djs\\item.xml";

    public void init(ServletConfig config)
        throws ServletException {

        super.init(config);
    }

    public void doGet(HttpServletRequest request,
        HttpServletResponse response)
        throws ServletException, IOException {

        doPost(request, response);
    }

    public void doPost(HttpServletRequest request,
        HttpServletResponse response) throws ServletException, IOException {

        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();

        // Load the movie file
        File file = new File(moviefile);
        FileReader reader = new FileReader(file);

        Parser parser;

        out.println("<html>");
        out.println("<head><title>XMLServlet</title></head>");
        out.println("<body>");

        try {

            // Get an instance of the SAXParserFactory
            SAXParserFactory spf = SAXParserFactory.newInstance();
            // Get a SAXParser instance from the factory
            SAXParser sp = spf.newSAXParser();

            // Create an instance of our HandlerBase
            SAXHandler handler = new SAXHandler();

            // Set the Document handler to call our SAXHandler when
            // SAX event occurs while parsing our XMLResource
            sp.parse(new InputSource(reader), handler);
            // After the resource has been parsed get the resulting table
            Hashtable cfgTable = handler.getTable();

            out.println("<table align=\"center\" width=\"600\">");
            out.println("<caption>XML Item</caption>");

            // Print the config settings that we are interested in.
            out.println("<tr><td align=\"left\">ID</td>" +
                "<td align=\"center\">" +
                (String)cfgTable.get(new String("ID")) + "</td></tr>");

            out.println("<tr><td align=\"left\">DESCRIPTION</td>" +
                "<td align=\"center\">" +
                (String)cfgTable.get(new String("DESCRIPTION")) +
                "</td></tr>");

            out.println("<tr><td align=\"left\">PRICE</td>" +
                "<td align=\"center\">" +
                (String)cfgTable.get(new String("PRICE")) +
                "</td></tr>");

            out.println("<tr><td align=\"left\">QUANTITY</td>" +
                "<td align=\"center\">" +
                (String)cfgTable.get(new String("QUANTITY")) +
                "</td></tr>");

            out.println("</table>");
        }
        catch (SAXException e) {

            out.println("Exception received: " +
                e.getMessage() + "<br>");
        }
        catch (ParserConfigurationException pce) {

            out.println("Exception received: " +
                pce.getMessage() + "<br>");
        }
        out.println("</body></html>");
    }

    public void destroy() {
    }
}