import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.naming.Context;
import javax.naming.InitialContext;

public class CalculateLoanBean implements SessionBean
{
    protected SessionContext ctx = null;

    public CalculateLoanBean()
    {
    }

    public Float calcMonthlyPayment(Integer months, Float principal)
	    throws RemoteException
    {
        Float yearlyIntTmp = getCurrentInterestRate();

        // Perform all of the calculations to figure out the monthly payment.
        float yearlyInt = yearlyIntTmp.floatValue() / 100;
        float monthlyInt = yearlyInt / 12;

        double payment = (principal.floatValue() * monthlyInt) /
            (1 - (Math.pow(1 / (1 + monthlyInt), months.intValue())));

        return new Float((float)payment);
    }

    public Float getCurrentInterestRate() throws RemoteException
    {
        Float yearlyInt = null;

        try
        {
            // Obtain the enterprise bean's environment naming context.
            Context initCtx = new InitialContext();
            Context myEnv = (Context)initCtx.lookup("java:comp/env");

            // Obtain the yearly interest rate from the bean's environment
            yearlyInt = (Float)myEnv.lookup("interestRate");
        }
        catch (javax.naming.NamingException nex)
        {
            // If there was a problem with JNDI, getting the yearly interest
            // rate, we will just default it to 8%
            yearlyInt = new Float(8.0f);
        }

        return yearlyInt;
    }

    public void ejbCreate() throws javax.ejb.CreateException,
        java.rmi.RemoteException
    {
    }
    public void ejbActivate() throws javax.ejb.EJBException,
        java.rmi.RemoteException
    {
    }
    public void ejbPassivate() throws javax.ejb.EJBException,
        java.rmi.RemoteException
    {
    }
    public void ejbRemove() throws javax.ejb.EJBException,
        java.rmi.RemoteException
    {
    }
    public void setSessionContext(SessionContext ctx)
        throws javax.ejb.EJBException, java.rmi.RemoteException
    {
        this.ctx = ctx;
    }
}
