import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletContext;

import LDAPManager;

public class LDAPDirectory implements Service {

    /** Creates new LDAPDirectory */
    public LDAPDirectory() {
        
    }

    /**
     * Single method to become a service.
     *
     * @throws Exception if any exceptions need to be thrown back
     * to the calling Controller.
    */
    public void execute(HttpServletRequest request,HttpServletResponse
        response,ServletContext context) throws Exception {
        
        // define what results we want from the search
        String[] returnAtts = {"sn",
            "givenName",
            "mail",
            "telephoneNumber"};

        // create a wildcard search filter
        String filter = "uid=*";

        // create and initialize an LDAPManager
        LDAPManager lm = new LDAPManager();
        lm.setSearchBase("ou=People,o=virtuas.com");

        // perform the search
        Vector results = null;

        // Get a list of All Persons
        results = lm.search(returnAtts, filter);
        request.setAttribute("directory", results);
    }    
}
