import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletContext;

import LDAPManager;

public class LDAPInsert implements Service {

    public LDAPInsert() {
        
    }

    /**
     * Single method to become a service.
     *
     * @throws Exception if any exceptions need to be thrown back
     * to the calling Controller.
    */
    public void execute(HttpServletRequest request,
        HttpServletResponse response,
        ServletContext context) throws Exception {
        
        String[] objectClass = {"top",
            "person",
            "organizationalPerson",
            "inetOrgPerson"};

        // Get the uid off of the request
        String uid = request.getParameter("uid");

        // Get the sn off of the request
        String sn = request.getParameter("sn");

        // Get the givenName off of the request
        String givenName = request.getParameter("givenName");

        // Get the mail off of the request
        String mail = request.getParameter("mail");

        // Get the tn off of the request
        String tn = request.getParameter("tn");
        
        // Create the UID
        String dn = "uid=" + uid + ",ou=People,o=virtuas.com";

        // Build the HashMap of Attribute to add
        HashMap atts = new HashMap();
        atts.put("cn", givenName + " " + sn);
        atts.put("sn", sn);
        atts.put("givenName", givenName);
        atts.put("uid", uid);
        atts.put("mail", mail);
        atts.put("telephoneNumber", tn);

        // create and initialize an LDAPManager
        LDAPManager lm = new LDAPManager();

        // Add the Person to the directory
        lm.add(dn, atts, objectClass);
    }    
}
