import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletContext;

import Service;
import java.sql.*;
import ConnectionPool.ConnectionPool;

public class Sell implements Service {

    public Sell() {

    }

    /*
     implemented method from Service interface
     */
    public void execute(HttpServletRequest request,
        HttpServletResponse response,
        ServletContext context) throws Exception {

        // Get the symbol from the request
        String symbol = request.getParameter("symbol");

        if ( symbol == null ) {

            throw new Exception("You must enter a stock symbol to purchase.");
        }

        // Get the price from the request
        String price = request.getParameter("price");

        if ( price == null ) {

            throw new Exception("You must enter a stock price to purchase.");
        }

        // Get a database connection from TRADER_POOL
        ConnectionPool pool = (ConnectionPool)context.getAttribute("TRADER_POOL");
        Connection con = pool.getConnection();

        try {

            if ( con != null ) {

                //  Check to see if there is an open BID satisfying our ASK
                Statement statement = con.createStatement();

                StringBuffer query = new StringBuffer("SELECT BID FROM STOCKS");
                query.append(" WHERE SYMBOL = \'" + symbol + "\'");

                // Get the stocks attributes
                ResultSet rs =
                    statement.executeQuery(query.toString());

                if ( rs.next() ) {

                    int bid = rs.getInt("bid");

                    int ask = ((new Integer(price)).intValue());

                    rs.close();

                    StringBuffer update = new StringBuffer("UPDATE STOCKS");

                    //  Check to see if there is an open BID satisfying our ASK
                    if ( bid >= ask && ask != 0 ) {

                        // if there is, then set the price to the bid price
                        // and reset the ask to 0
                        update.append(" SET PRICE = " + price);
                        update.append(", BID = 0");
                        update.append(" WHERE SYMBOL = '" + symbol + "'");
                    }
                    else {

                        // if there is no match set the ask price to the offered
                        // price
                        update.append(" SET ASK = " + price);
                        update.append(" WHERE SYMBOL = '" + symbol + "'");
                    }
                    statement.executeUpdate(update.toString());
                }
            }
        }
        finally {

            pool.releaseConnection(con);
        }
    }
}
